//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
   #include <math.h>
#include "Unit1.h"

//  1 - name of ability to search (percents)
//  2 - bonus to fight value (percents)
//  3 - bonus to ai value (percents)
//  4 - bonus to damage (percents) not used now
//  5 - reserved
//  6 - reserved
const AnsiString Abilities[100][6]={
{"NON_LIVING","2","2","0","0","0"},
{"UNDEAD",  "2","2","0","0","0"},
{"DRAGON_NATURE",    "1","1","0","0","0"},
{"KING1",  "1","1","0","0","0"},
{"KING2",   "2","2","0","0","0"},
{"KING3",  "3","3","0","0","0"},
{"FEARLESS",  "5","5","0","0","0"},
{"NO_LUCK",    "1","1","0","0","0"},
{"NO_MORALE",   "1","1","0","0","0"},
{"SELF_MORALE",  "2","2","0","0","0"},
{"SELF_LUCK",  "2","2","0","0","0"},


{"FLYING", "7","7","0","0","0"},
{"SHOOTER",  "10","10","0","0","0"},
{"CHARGE_IMMUNITY", "2","2","0","0","0"},
{"ADDITIONAL_ATTACK",  "0","0","0","0","0"},
{"UNLIMITED_RETALIATIONS",  "10","10","0","0","0"},
{"ADDITIONAL_RETALIATION",  "5","5","0","0","0"},
{"JOUSTING", "3","3","0","0","0"},
{"HATE",  "1","1","0","0","0"},
{"SPELL_LIKE_ATTACK",  "3","3","0","0","0"},
{"THREE_HEADED_ATTACK", "0","0","0","0","0"},
{"ATTACKS_ALL_ADJACENT", "0","0","0","0","0"},
{"TWO_HEX_ATTACK_BREATH","0","0","0","0","0"},
{"RETURN_AFTER_STRIKE", "3","3","0","0","0"},
{"ENEMY_DEFENCE_REDUCTION",  "0","0","0","0","0"},
{"GENERAL_DAMAGE_REDUCTION","5","5","0","0","0"},
{"GENERAL_ATTACK_REDUCTION", "0","0","0","0","0"},
{"DEFENSIVE_STANCE", "5","5","0","0","0"},
{"NO_DISTANCE_PENALTY", "7","7","0","0","0"},
{"NO_MELEE_PENALTY", "5","5","0","0","0"},
{"NO_WALL_PENALTY",   "3","3","0","0","0"},
{"FREE_SHOOTING",    "10","10","0","0","0"},
{"BLOCKS_RETALIATION","5","5","0","0","0"},

{"CATAPULT",    "10","10","0","0","0"},
{"CHANGES_SPELL_COST_FOR_ALLY", "7","7","0","0","0"},
{"CHANGES_SPELL_COST_FOR_ENEMY",  "7","7","0","0","0"},
{"SPELL_RESISTANCE_AURA",  "5","5","0","0","0"},
{"HP_REGENERATION",   "2","2","0","0","0"},
{"FULL_HP_REGENERATION","3","3","0","0","0"},
{"MANA_DRAIN",      "3","3","0","0","0"},
{"MANA_CHANNELING",     "3","3","0","0","0"},
{"LIFE_DRAIN",   "5","5","0","0","0"},
{"DOUBLE_DAMAGE_CHANCE",  "0","0","0","0","0"},
{"FEAR",  "10","10","0","0","0"},
{"HEALER",   "3","3","0","0","0"},
{"FIRE_SHIELD",  "7","7","0","0","0"},
{"MAGIC_MIRROR", "4","4","0","0","0"},
{"ACID_BREATH",   "3","3","0","0","0"},
{"DEATH_STARE",    "10","10","0","0","0"},

{"SPELLCASTER",   "5","5","0","0","0"},
{"ENCHANTER",    "10","10","0","0","0"},
{"RANDOM_SPELLCASTER", "4","4","0","0","0"},
{"SPELL_AFTER_ATTACK","3","3","0","0","0"},
{"SPELL_BEFORE_ATTACK", "3","3","0","0","0"},
{"CASTS",               "0","0","0","0","0"},
{"SPECIFIC_SPELL_POWER",  "0","0","0","0","0"},
{"CREATURE_SPELL_POWER",  "0","0","0","0","0"},
{"CREATURE_ENCHANT_POWER",  "0","0","0","0","0"},
{"DAEMON_SUMMONING", "7","7","0","0","0"},
{"REBIRTH",      "5","5","0","0","0"},
{"ENCHANTED",     "5","5","0","0","0"},

{"LEVEL_SPELL_IMMUNITY", "10","10","0","0","0"},
{"MAGIC_RESISTANCE",      "5","5","0","0","0"},
{"SPELL_DAMAGE_REDUCTION",   "2","2","0","0","0"},
{"MORE_DAMAGE_FROM_SPELL","-2","-2","0","0","0"},
{"WATER_IMMUNITY",  "2","2","0","0","0"},
{"EARTH_IMMUNITY",  "2","2","0","0","0"},
{"AIR_IMMUNITY",   "2","2","0","0","0"},
{"MIND_IMMUNITY",     "2","2","0","0","0"},
{"SPELL_IMMUNITY",    "1","1","0","0","0"},
{"DIRECT_DAMAGE_IMMUNITY",  "10","10","0","0","0"},
{"RECEPTIVE",  "3","3","0","0","0"},

{"POISON",  "3","3","0","0","0"},
{"SLAYER",   "3","3","0","0","0"},
{"BIND_EFFECT",   "0","0","0","0","0"},
{"FORGETFULL",    "-7","-7","0","0","0"},
{"NOT_ACTIVE",     "-10","-10","0","0","0"},
{"ALWAYS_MINIMUM_DAMAGE", "-5","-5","0","0","0"},
{"ALWAYS_MAXIMUM_DAMAGE",    "7","7","0","0","0"},
{"ATTACKS_NEAREST_CREATURE",   "-5","-5","0","0","0"},
{"IN_FRENZY",  "2","2","0","0","0"},
{"HYPNOTIZED" "-10","-10","0","0","0"}


};



struct abilityCost
{
AnsiString abString;
int Value;
int DamageBonusInPercent;
int BonusToAIInPercent;
int BonusToFightInPercent;};

abilityCost AbilitiesList[100];




//Program author: Macron 1
//I dont know about licence type yet:-)
//Original formulas of AI/Fight Value are given by
//GrayFace (http://wforum.heroes35.net/)
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
int minv(int a,int b)
{
if(a<=b) return a;
else
return b;
}

long CalkDamageCoeff(int Attack,int Defence)
{int A=Attack;
int D=Defence;
long Result=-1;
  int AvgSkill = 4;
  A=A+AvgSkill;
  D=D+AvgSkill;
  if (A>=D)
  {

    Result=1 + minv((((double)(A-D))*0.05), 3);

    }
  else
  {
    Result=1 - minv(((double)(D-A))*0.025, 0.7);
  }
  return Result;
}

const int stdAttack[159]=
{
4,6,6,6,8,9,10,12,12,12,15,16,20,30,5,6,6,7,9,9,9,9,9,9,15,15,18,
27,3,4,6,7,7,9,11,12,12,12,16,16,19,24,2,4,6,7,10,10,10,10,13,13,
16,16,19,26,5,6,5,5,7,7,10,10,13,13,16 ,18,17,19,4,5,6,6,9,10,9 ,10,
14,15,15,16,19,25,4,5,7,8,8,8,13,13,13,13,15,17,17,19,3,4,5,6,10,
11,7,8,11,12,14,14,16,18,9,10,10,8,11,13,2,2,15,15,0,8,0,11,0,9,0,
12,18,21,50,40,20,30,17,12,4,1,6,7,9,8,14,10,10,0,0,10,40,36,32,
35,25,33,25,25,28};

const int stdDefence[159]=
{
5,5,3,3,8,9,12,12,7,10,15,16,20,30,3,3,7,7,5,5,8,10,12,12,14,14,18,27,
3,4,6,7,10,10,8,9,12,12,13,13,16,24,3,4,4,4,6,8,10,10,13,13,12,14,21,28,
4,6,5,5,7,7,9,10,10,10,16,18,15,17,3,4,5,6,7,8,9,10,12,15,13,14,19,25,
2,3,5,5,4,4,7,7,11,11,12,13,17,19,5,6,6,8,14,16,9,10,11,12,14,14,18,20,
9,10,8,10,12,12,2,2,13,13,0,10,0,11,0,9,0,8,18,18,50,40,20,30,12,10,2,
1,5,7,8,3,7,10,10,0,5,5,40,36,32,37,23,33,25,27,28};



long CalkAttDamage(int Att,double EnemyDefenceReduction)
{
     long Result=-1;
  Result=0;
  for (int i=0;i<=158;i++)
  {
    Result=Result +CalkDamageCoeff(Att, (int)(stdDefence[i]*(1.-EnemyDefenceReduction)));
    }
  Result=Result/159;
  return Result;
  }

long CalkDefDamage(int Def,double GeneralAttackReduction)
{
     long Result=-1;
  Result=0;
  for (int i=0;i<=158;i++)
  {
    Result=Result +CalkDamageCoeff((int)(stdAttack[i]*(1.-GeneralAttackReduction)), Def);
    }
  Result=Result/159;
  return Result;
  }





long CalkFinal(int AttV, int DefV, double ProtPower, double Mul)
{
long Result=0;
  if (AttV==0){
    Result= 0;
    }
  else
  {
    Result= sqrt(AttV)*pow(DefV, ProtPower)*Mul;
  }
return Result;
}

int CalculateValues(int Attack,int Defence,int HitPoints,int MinDamage,int MaxDamage,double GeneralAttackReduction,double EnemyDefenceReduction,int out[2])
{
const   double DmgFactor = 0.5;
const   double   ProtPowerFight = 0.57; // Less for Fight value
const   double   ProtPowerAI = 0.67; // More for AI value
const   double   MulFight = 1;
const   double   MulAI = 0.6;
       int Damage1=MinDamage;
       int Damage2=MaxDamage;

 long FinalV,  FinalAI;
    int AttV=CalkAttDamage(Attack,EnemyDefenceReduction)*(DmgFactor*Damage2+(1-DmgFactor)*Damage1)*50. +1.;
    int DefV=(7./CalkDefDamage(Defence,GeneralAttackReduction)+1.)*HitPoints + 1.;
    FinalV=CalkFinal(AttV, DefV, ProtPowerFight, MulFight);
    FinalAI=CalkFinal(AttV, DefV, ProtPowerAI, MulAI);
    out[0]=FinalV;
    out[1]=FinalAI;
}


int FillAbilitiesList(abilityCost AbilitiesList[100])
{
AbilitiesList[0].abString="SHOOTER";
AbilitiesList[0].Value=0;
AbilitiesList[0].DamageBonusInPercent=0;
AbilitiesList[0].BonusToAIInPercent=10;
AbilitiesList[0].BonusToFightInPercent=10;




}



int maxof(int v1,int v2)
{
if(v1<=0) return v2; else return v1;

}

int minof(int v1,int v2)
{
if(v1<=v2) return v1; else return v2;

}


int GetValueFromList(TStringList *templ,AnsiString SearchString)
{
int Level=-1;
for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchString;//    "\"level\"";
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{
 AnsiString LevelStr=templ->Strings[g].SubString(posl+Cur.Length(),templ->Strings[g].Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));

  if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 Level=StrToInt(LevelStr);
  break;
  }
}

   }
   return Level;

}


int GetValueOfAbility(TStringList *templ,AnsiString SearchString)
{

 int Value=-1;

for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchString;//"\"ability name\"";
int end=0;
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{

AnsiString CommonString="";//templ->Strings[g];
int startstr=g;
int endstr=0;

for(int tekstr=g;tekstr< templ->Count;tekstr++)
   {
   int f=templ->Strings[tekstr].Pos("}");
    CommonString=CommonString+templ->Strings[tekstr].Trim();
     if( templ->Strings[tekstr].Pos("}")) { endstr=tekstr;break;}

   }
  if(endstr==0) break;
//search max


Cur="\"val\"";
posl=CommonString.Pos(Cur);
int posComments1=CommonString.Pos("\\");
if((posl!=0)&&((posComments1==0)||(posComments1>posl))   )
if(posl!=0)
{
 AnsiString LevelStr=CommonString.SubString(posl+Cur.Length(),CommonString.Length()-posl);
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';

 LevelStr.Trim();
 Value=StrToInt(LevelStr);
 // break;
  }
   if(Value!=-1) break;
}



}
 if(Value!=-1) break;
}
return Value;
}


int GetMaxMinFromList(TStringList *templ,AnsiString SearchString, int out[2])
{

 int MaxDamage=-1,MinDamage=-1;

for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchString;//"\"damage\"";
int end=0;
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{

AnsiString CommonString=templ->Strings[g];
int startstr=g;
int endstr=0;

for(int tekstr=g;tekstr< templ->Count;tekstr++)
   {
   int f=templ->Strings[tekstr].Pos("}");
    CommonString=CommonString+templ->Strings[tekstr].Trim();
     if( templ->Strings[tekstr].Pos("}")) { endstr=tekstr;break;}
   }
  if(endstr==0) break;
//search max


Cur="\"max\"";
posl=CommonString.Pos(Cur);
int posComments1=CommonString.Pos("\\");
if((posl!=0)&&((posComments1==0)||(posComments1>posl))   )
if(posl!=0)
{
 AnsiString LevelStr=CommonString.SubString(posl+Cur.Length(),CommonString.Length()-posl);
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';

 LevelStr.Trim();
 MaxDamage=StrToInt(LevelStr);
 // break;
  }
}
 if(MaxDamage==-1) break;

Cur="\"min\"";
posl=CommonString.Pos(Cur);
int posComments2=CommonString.Pos("\\");
if((posl!=0)&&((posComments2==0)||(posComments2>posl))   )
{
 AnsiString LevelStr=CommonString.SubString(posl+Cur.Length(),CommonString.Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));

  if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 MinDamage=StrToInt(LevelStr);
  break;
  }
}
  }
 }
  out[0]=MaxDamage;
  out[1]=MinDamage;

if((MinDamage!=-1)&&(MaxDamage!=-1))
  return 0;
  else return -1;

}


int ReplaceValue(TStringList *templ,AnsiString SearchValue,int WriteValue)
{

 int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;
for(int g=0;g<templ->Count;g++)
{

AnsiString Cur=SearchValue;//"\"aiValue\"";
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{
AnsiString Endstr=         templ->Strings[g].SubString(posl,templ->Strings[g].Length()-posl);
AIValueStart=posl+Endstr.Pos(":")-1;
Endstr=Endstr.SubString(1,minof(maxof(Endstr.Pos(",")-1,Endstr.Length()),Endstr.Length()));
AIValueEnd=posl+Endstr.Length()-1;

AIValueString=g;
 AnsiString LevelStr=templ->Strings[g].SubString(posl+Cur.Length(),templ->Strings[g].Length()-posl);
 LevelStr=LevelStr.Trim();
 if(LevelStr[1]==':')
 {

 LevelStr=LevelStr.SubString(2,minof(maxof(LevelStr.Pos(",")-2,LevelStr.Length()),LevelStr.Length()));
   if(LevelStr[LevelStr.Length()]=='}') LevelStr[LevelStr.Length()]='\0';
 LevelStr.Trim();
 AIValue=StrToInt(LevelStr);
  break;
  }
}
}
int AIValueOld=AIValue;
AIValue=WriteValue;

 if(AIValueString!=-1)
{
AnsiString Temp=templ->Strings[AIValueString].SubString(1,AIValueStart);
Temp=Temp+" "+IntToStr(AIValue);
Temp=Temp+templ->Strings[AIValueString].SubString(AIValueEnd+1,templ->Strings[AIValueString].Length()-AIValueStart);
 templ->Strings[AIValueString]=Temp;
}

return 0;
}




int ReplaceValueMinMax(TStringList *templ,AnsiString SearchValue,int WriteValueMin,int WriteValueMax)
{


for(int g=0;g<templ->Count;g++)
{
//      int AIValue=-1;
// int AIValueString=-1;
// int AIValueEnd=-1;
// int AIValueStart=-1;
AnsiString Cur=SearchValue;//"\"aiValue\"";
int posl=templ->Strings[g].Pos(Cur);
int posComments=templ->Strings[g].Pos("\\");
if((posl!=0)&&((posComments==0)||(posComments>posl))   )
{

for(int n=g;n<templ->Count;n++)
{
 int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;
AnsiString Cur1="\"max\"";
int posl1=templ->Strings[n].Pos(Cur1);
int posComments1=templ->Strings[n].Pos("\\");
if((posl1!=0)&&((posComments1==0)||(posComments1>posl1))   )
{
  AnsiString Endstr1=         templ->Strings[n].SubString(posl1,templ->Strings[n].Length()-posl1+1);
int AIValueStart1=posl+Endstr1.Pos(":")-1;
Endstr1=Endstr1.SubString(1,minof(maxof(Endstr1.Pos(",")-1,Endstr1.Length()),Endstr1.Length()));
//AnsiString NewStr=templ->Strings[n].SubString(1,posl1)+"\"max\":"+StrToInt(WriteValueMax);

//NewStr=NewStr+templ->Strings[n].SubString(minof(maxof(Endstr1.Pos(",")-1,Endstr1.Length()),Endstr1.Length()),Endstr1.Length());
int AIValueEnd1=posl+Endstr1.Length();

AnsiString Temp=templ->Strings[n].SubString(1,AIValueStart1);
Temp=Temp+": "+IntToStr(WriteValueMax);
Temp=Temp+templ->Strings[n].SubString(AIValueEnd1+1,templ->Strings[n].Length()-AIValueStart1);
  templ->Strings[n]=Temp;
break;
}
}


for(int n=g;n<templ->Count;n++)
{
 int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;
AnsiString Cur1="\"min\"";
int posl1=templ->Strings[n].Pos(Cur1);
int posComments1=templ->Strings[n].Pos("\\");
if((posl1!=0)&&((posComments1==0)||(posComments1>posl1))   )
{
  AnsiString Endstr1=         templ->Strings[n].SubString(posl1,templ->Strings[n].Length()-posl1+1);
int AIValueStart1=posl+Endstr1.Pos(":")-1;
Endstr1=Endstr1.SubString(1,minof(maxof(Endstr1.Pos(",")-1,Endstr1.Length()),Endstr1.Length()));

//NewStr=NewStr+templ->Strings[n].SubString(minof(maxof(Endstr1.Pos(",")-1,Endstr1.Length()),Endstr1.Length()),Endstr1.Length());
int AIValueEnd1=posl+Endstr1.Length();

AnsiString Temp=templ->Strings[n].SubString(1,AIValueStart1);
Temp=Temp+": "+IntToStr(WriteValueMin);
Temp=Temp+templ->Strings[n].SubString(AIValueEnd1+1,templ->Strings[n].Length()-AIValueStart1);
  templ->Strings[n]=Temp;
break;
}
}



}


}


return 0;
}

bool GetBooleanAbilityExistence(TStringList *templ,AnsiString FindWhat)
{
bool IsTrue=false;
for(int g=0;g<templ->Count;g++)
{
int posl=templ->Strings[g].Pos(FindWhat);
int posType=templ->Strings[g].Pos("\"type\"");

int posComments=templ->Strings[g].Pos("\\");
 if((posl!=0)&&(posl>posType)&&((posComments==0)||(posComments>posl))   )

//if(templ->Strings[g].Pos("\"SHOOTER\"")||templ->Strings[g].Pos("\"SPELL_AFTER_ATTACK\"")||templ->Strings[g].Pos("\"SPELL_BEFORE_ATTACK\""))
{
IsTrue=true;
  break;
  }
}
 return IsTrue;
}



TForm1 *Form1;


//1 - attack
//2 - defense
//3 - hit points
//4 - damage min
//5 - damage max
//6 - level of creature
int BalanceProcedure(TStringList *templ,bool IsShooter,int Params[10],int OutParams[10])
{
int res1,res2,res3,res4;
int AttackSkill=Params[0];
int DefenceSkill=Params[1];
int HitPoints=Params[2];
int MaxDamage=Params[3];
int MinDamage=Params[4];
int Level=Params[5];
if((Level>7)||(Level<=0)) goto exitp;

 if(AttackSkill<0) AttackSkill=0;
  if(DefenceSkill<0) DefenceSkill=0;
  if(MinDamage<0) MinDamage=0;
  if(MaxDamage<0) MaxDamage=0;
    if(HitPoints<=0) HitPoints=1;
switch (Level)
{
case 1:
{
 if(AttackSkill>7) AttackSkill=7;
 if(DefenceSkill>7) DefenceSkill=7;
 if(MaxDamage>4) MaxDamage=4;
 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;

 if(HitPoints>11) HitPoints=11;
 break;
}
case 2:
 {
 if(AttackSkill>10) AttackSkill=10;
 if(AttackSkill<4) AttackSkill=4;
 if(DefenceSkill>7) DefenceSkill=7;
  if(DefenceSkill<2) DefenceSkill=2;
 if(MaxDamage>5) MaxDamage=5;
 if(MaxDamage<2) MaxDamage=2;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<2) MinDamage=min(2,MaxDamage);

 if(HitPoints>16) HitPoints=16;
 if(HitPoints<9) HitPoints=9;
  break;
}
case 3:
{
 if(AttackSkill>11) AttackSkill=11;
 if(AttackSkill<6) AttackSkill=6;
 if(DefenceSkill>11) DefenceSkill=11;
  if(DefenceSkill<3) DefenceSkill=3;
 if(MaxDamage>8) MaxDamage=8;
 if(MaxDamage<1) MaxDamage=1;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<1) MinDamage=min(1,MaxDamage);

 if(HitPoints>38) HitPoints=38;
 if(HitPoints<16) HitPoints=9;
  break;
}
case 4:
{
 if(AttackSkill>14) AttackSkill=14;
 if(AttackSkill<6) AttackSkill=6;
 if(DefenceSkill>13) DefenceSkill=13;
  if(DefenceSkill<6) DefenceSkill=6;
 if(MaxDamage>13) MaxDamage=13;
 if(MaxDamage<1) MaxDamage=1;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<1) MinDamage=min(1,MaxDamage);

 if(HitPoints>66) HitPoints=66;
 if(HitPoints<18) HitPoints=18;
  break;
}
case 5:
{
 if(AttackSkill>17) AttackSkill=17;
 if(AttackSkill<7) AttackSkill=7;
 if(DefenceSkill>17) DefenceSkill=17;
  if(DefenceSkill<7) DefenceSkill=7;
 if(MaxDamage>22) MaxDamage=22;
 if(MaxDamage<3) MaxDamage=3;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<3) MinDamage=min(3,MaxDamage);

 if(HitPoints>77) HitPoints=77;
 if(HitPoints<27) HitPoints=27;
  break;
}
case 6:
{
   if(AttackSkill>19) AttackSkill=19;
 if(AttackSkill<11) AttackSkill=11;
 if(DefenceSkill>19) DefenceSkill=19;
  if(DefenceSkill<11) DefenceSkill=11;
 if(MaxDamage>33) MaxDamage=33;
 if(MaxDamage<9) MaxDamage=9;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<9) MinDamage=min(9,MaxDamage);

 if(HitPoints>132) HitPoints=132;
 if(HitPoints<63) HitPoints=63;
  break;
}


case 7:
{
   if(AttackSkill>33) AttackSkill=33;
 if(AttackSkill<15) AttackSkill=15;
 if(DefenceSkill>33) DefenceSkill=33;
  if(DefenceSkill<15) DefenceSkill=15;
 if(MaxDamage>66) MaxDamage=66;
 if(MaxDamage<23) MaxDamage=23;

 if(MinDamage>MaxDamage) MinDamage=MaxDamage-1;
 if(MinDamage<23) MinDamage=min(23,MaxDamage);

 if(HitPoints>330) HitPoints=330;
 if(HitPoints<135) HitPoints=135;
}
}

 res1=ReplaceValue(templ,"\"attack\"",(int)AttackSkill);
res2=ReplaceValue(templ,"\"defense\"",(int)DefenceSkill);
 res3=ReplaceValue(templ,"\"hitPoints\"",(int)HitPoints);
 res4=ReplaceValueMinMax(templ,"\"damage\"",MinDamage,MaxDamage);
exitp:




//int OutParams[10]={0,0,0,0,0,0,0,0,0,0};
OutParams[0]=AttackSkill;
OutParams[1]=DefenceSkill;
OutParams[2]=HitPoints;
OutParams[3]=MaxDamage;
OutParams[4]=MinDamage;
//OutParams[5]=Level;

}



int      correctValues(AnsiString FilePath,bool BalanceParams)
{
  TStringList *templ=new TStringList;
templ->LoadFromFile(FilePath);
  AnsiString SaveName=FilePath+"_back";
templ->SaveToFile(SaveName);

      int FightValue=-1;
 int FightValueString=-1;
 int FightValueEnd=-1;
 int FightValueStart=-1;

    int AIValue=-1;
 int AIValueString=-1;
 int AIValueEnd=-1;
 int AIValueStart=-1;

int res=0;

//Search for level of creature
AnsiString a;

int Level=GetValueFromList(templ,"\"level\"");
int HitPoints=GetValueFromList(templ,"\"hitPoints\"");

int AttackSkill=GetValueFromList(templ,"\"attack\"");
int DefenceSkill =GetValueFromList(templ,"\"defense\"");
int Speed =GetValueFromList(templ,"\"speed\"");



bool IsShooter=GetBooleanAbilityExistence(templ,"\"SHOOTER\"");
//bool IsSpellAfterAttack=GetBooleanAbilityExistence(templ,"\"SPELL_AFTER_ATTACK\"");
//bool IsSpellBeforeAttack=GetBooleanAbilityExistence(templ,"\"SPELL_BEFORE_ATTACK\"");
bool IsTwoHex=GetBooleanAbilityExistence(templ,"\"TWO_HEX_BREATH_ATTACK\"");
bool IsThreeHeadedAttack=GetBooleanAbilityExistence(templ,"\"THREE_HEADED_ATTACK\"");
bool IsAttacksAllAdjacent=GetBooleanAbilityExistence(templ,"\"ATTACKS_ALL_ADJACENT\"");
//bool IsDeathStare=GetBooleanAbilityExistence(templ,"\"DEATH_STARE\"");
//bool IsFireShield=GetBooleanAbilityExistence(templ,"\"FIRE_SHIELD\"");
bool IsAdditionalAttack=GetBooleanAbilityExistence(templ,"\"ADDITIONAL_ATTACK\"");
bool IsAcidBreath=GetBooleanAbilityExistence(templ,"\"ACID_BREATH\"");
bool IsPoison=GetBooleanAbilityExistence(templ,"\"POISON\"");
bool IsDoubleDamage=GetBooleanAbilityExistence(templ,"\"DOUBLE_DAMAGE_CHANCE\"");
bool IsMinimumDamage=GetBooleanAbilityExistence(templ,"\"ALWAYS_MINIMUM_DAMAGE\"");
bool IsMaximumDamage=GetBooleanAbilityExistence(templ,"\"ALWAYS_MAXIMUM_DAMAGE\"");
bool IsEnemyDefenceReduction=GetBooleanAbilityExistence(templ,"\"ENEMY_DEFENCE_REDUCTION\"");
bool IsGeneralAttackReduction=GetBooleanAbilityExistence(templ,"\"GENERAL_ATTACK_REDUCTION\"");

int outValue[2]={-1,-1};
 int MaxDamage=-1,MinDamage=-1;
if(GetMaxMinFromList(templ,"\"damage\"",outValue)==0)
{
MaxDamage=outValue[0];
MinDamage=outValue[1];

}




 AIValue=-1;
 AIValueString=-1;
 AIValueEnd=-1;
 AIValueStart=-1;

  FightValue=-1;
  FightValueString=-1;
  FightValueEnd=-1;
  FightValueStart=-1;


if(MaxDamage==-1) return (-1);
if(MinDamage==-1) return (-1);
if( DefenceSkill ==-1) return (-1);
 if( AttackSkill ==-1) return (-1);
if( Level ==-1) return (-1);
    if(HitPoints==-1) return (-1);


//BalanceParams = true

if(BalanceParams==true)
{
//1 - attack
//2 - defense
//3 - hit points
//4 - damage min
//5 - damage max
//6 - level of creature
int Params[10]={0,0,0,0,0,0,0,0,0,0};
Params[0]=AttackSkill;
Params[1]=DefenceSkill;
Params[2]=HitPoints;
Params[3]=MaxDamage;
Params[4]=MinDamage;
Params[5]=Level;

int OutParams[10]={0,0,0,0,0,0,0,0,0,0};
int resbal=BalanceProcedure(templ,IsShooter,Params,OutParams);
AttackSkill=OutParams[0];
DefenceSkill=OutParams[1];
HitPoints=OutParams[2];
MaxDamage=OutParams[3];
MinDamage=OutParams[4];

//balance map quantity (if creature has no string "upgrades", it is treated as upgrade
bool IsUpgraded=!GetBooleanAbilityExistence(templ,"\"upgrades\"");

if((Level>0)&&(Level<=7))
{
int MinQuality=0,MaxQuality=0;

switch (Level)
{
case 1:
{
if(IsUpgraded==true)
{
MaxQuality=30;
MinQuality=20;
}
else
{
MaxQuality=50;
MinQuality=20;
}
break;
}
case 2:
{
if(IsUpgraded==true)
{
MaxQuality=25;
MinQuality=16;
}
else
{
MaxQuality=30;
MinQuality=25;
}
break;
}
case 3:
{
if(IsUpgraded==true)
{
MaxQuality=20;
MinQuality=12;
}
else
{
MaxQuality=25;
MinQuality=12;
}
break;
}
case 4:
{
if(IsUpgraded==true)
{
MaxQuality=16;
MinQuality=10;
}
else
{
MaxQuality=20;
MinQuality=10;
}
break;
}
case 5:
{
if(IsUpgraded==true)
{
MaxQuality=12;
MinQuality=8;
}
else
{
MaxQuality=16;
MinQuality=8;
}
break;
}
case 6:
{
if(IsUpgraded==true)
{
MaxQuality=10;
MinQuality=5;
}
else
{
MaxQuality=12;
MinQuality=5;
}
break;
}
case 7:
{
if(IsUpgraded==true)
{
MaxQuality=8;
MinQuality=3;
}
else
{
MaxQuality=10;
MinQuality=4;
}
break;
}

}
if((MinQuality>0)&&(MaxQuality>0))
 {

 int resupg=ReplaceValueMinMax(templ,"\"advMapAmount\"",MinQuality,MaxQuality);
 }

}



}



 //write new data

//damage correction
int CorrMaxDamage=MaxDamage;
int CorrMinDamage=MinDamage;

if(IsMinimumDamage==true)  CorrMaxDamage=MinDamage;
if(IsMaximumDamage==true)  CorrMinDamage=MaxDamage;


if(IsThreeHeadedAttack==true) {CorrMaxDamage=CorrMaxDamage*3;}
if(IsAttacksAllAdjacent==true) {CorrMaxDamage=CorrMaxDamage*6;}
if(IsAdditionalAttack==true) {CorrMaxDamage=CorrMaxDamage*2;}
if(IsTwoHex==true) {CorrMaxDamage=CorrMaxDamage*2;}
//if(IsDeathStare|| IsAcidBreath||  IsFireShield)
//{CorrMaxDamage=CorrMaxDamage*3/2;CorrMinDamage=CorrMinDamage*3/2};


if(IsAcidBreath==true)
{
int AcidDamage=GetValueOfAbility(templ,"\"ACID_BREATH\"");
CorrMaxDamage=CorrMaxDamage +AcidDamage;
}

if(IsPoison==true)
{
int PoisonDamage=GetValueOfAbility(templ,"\"POISON\"");
CorrMaxDamage=CorrMaxDamage +PoisonDamage;
}

if( IsDoubleDamage==true)
{
int DoubleDamageChance= GetValueOfAbility(templ,"\"DOUBLE_DAMAGE_CHANCE\"");
if(DoubleDamageChance>0)
CorrMaxDamage=CorrMaxDamage +MaxDamage;

}


// defence, attack reduction values
double EnemyDefenceReduction=0;
double GeneralAttackReduction=0;
//double GeneralAttackReduction=0;
if(IsEnemyDefenceReduction==true)
{
EnemyDefenceReduction= GetValueOfAbility(templ,"\"ENEMY_DEFENCE_REDUCTION\"")/100.;
if( EnemyDefenceReduction>=1.)  EnemyDefenceReduction=1.;
if( EnemyDefenceReduction>=1.)  EnemyDefenceReduction=1.;
}

if(IsGeneralAttackReduction==true)
{
GeneralAttackReduction= GetValueOfAbility(templ,"\"GENERAL_ATTACK_REDUCTION\"")/100.;
if(GeneralAttackReduction>=1.) GeneralAttackReduction=1.;
}


int out[2]={0,0};
int resf=CalculateValues(AttackSkill,DefenceSkill,HitPoints,CorrMinDamage,CorrMaxDamage,GeneralAttackReduction,EnemyDefenceReduction,out);

//int resf=CalculateValues(AttackSkill,DefenceSkill,HitPoints,MinDamage,MaxDamage,out);
FightValue=out[0];
AIValue=out[1];


//other abilities to bonus
double CorrFightValue=FightValue;
double CorrAIValue=AIValue;



for (int r=0;r<82;r++)
{
bool IsExist=GetBooleanAbilityExistence(templ,"\""+Abilities[r][0]+"\"");
if (IsExist==true)
{
CorrFightValue=CorrFightValue*((100.+StrToFloat(Abilities[r][1]))/100.);
CorrAIValue=CorrAIValue*((100.+StrToFloat(Abilities[r][2]))/100.);
}

}

//speed bonus
if(Speed>5)
{
if(Speed<=10)
{
CorrFightValue=CorrFightValue*1.05;
CorrAIValue=CorrAIValue*1.05;
}
else
{
CorrFightValue=CorrFightValue*1.10;
CorrAIValue=CorrAIValue*1.10;
}

}




 int res1=ReplaceValue(templ,"\"aiValue\"",(int)CorrAIValue);
 int res2=ReplaceValue(templ,"\"fightValue\"",(int)CorrFightValue);


templ->SaveToFile(FilePath);

return 0;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonStartClick(TObject *Sender)
{
if(OpenDialog1->Execute())
{
this->ButtonStart->Enabled=false;
this->ButtonExit->Enabled=false;

for(int i=0;i< OpenDialog1->Files->Count;i++) //

  {
  //if(CheckBoxBalance->Checked())
  int ret=correctValues(OpenDialog1->Files->Strings[i],CheckBoxBalance->Checked);
  if(ret!=0) ShowMessage("Error working with "+OpenDialog1->Files->Names[i]);
  }

}
ShowMessage("Calculation is finished!");
this->ButtonStart->Enabled=true;
this->ButtonExit->Enabled=true;

}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonExitClick(TObject *Sender)
{
exit(0);        
}
//---------------------------------------------------------------------------



